 _G=_G or GLOBAL _M=_M or env _G.setmetatable(_M,{__index=function(t,k)return _G.rawget(_G,k)end})

local TUNING = _G.TUNING
local require = _G.require
local ModIndex = require "modindex"
local yiyumapscreen = require "screens/yiyumapscreen"
local YiyuDialogScreen = require "screens/yiyudialog"
local YiyuFinditScreen = require "screens/yiyufindit"
local Image = require "widgets/image"
TUNING.YIYUKEY_MAP = GetModConfigData("Special_settings")
TUNING.YIYUICONSLANGUAGE = GetModConfigData("icon_language")

local function Inject(comp,fn_name,fn)
AddComponentPostInit(comp, function(self)
	local old = self[fn_name]
	self[fn_name] = function(self,...)
		old(self,...)
		fn(self.inst)
	end
end)
end

AddPlayerPostInit(function(inst) if not inst.components.yiyunetwork then inst:AddComponent("yiyunetwork") end _G.TheInput:AddKeyDownHandler(TUNING.YIYUKEY_MAP, function() if not _G.IsPaused() then _G.TheFrontEnd:PushScreen(YiyuDialogScreen()) end end) end) _G.Notice_yiyu = function() local player = GLOBAL.GetPlayer() return player.components.yiyunetwork.checkmap() end

-------------------------------------------------------
--[[
local tree_icons = 
	{
	"evergreen",
	"evergreen_sparse",
	"deciduoustree",
	"palmtree",
	"teatree",--茶树
	"jungletree",
	"clawpalmtree",--软木树
	"rainforesttree",--雨林树
	"spider_monkey_tree",
	}

local function check_stump(inst)
if inst then
	inst.entity:AddMiniMapEntity()
	if inst:HasTag("stump") then
		if inst.prefab == "palmtree" then if TUNING.YIYUICONHIDE8 == _G.yiyu_iconhide8 then inst.MiniMapEntity:SetIcon( "yiyu_palmtree.tex" ) end end
		if inst.prefab == "deciduoustree" then if TUNING.YIYUICONHIDE7 == _G.yiyu_iconhide7 then inst.MiniMapEntity:SetIcon( "yiyu_deciduoustree.tex" ) end end
		if inst.prefab == "spider_monkey_tree" then inst.MiniMapEntity:SetIcon( "yiyu_deciduoustree.tex" ) end
		if inst.prefab == "evergreen" then if TUNING.YIYUICONHIDE5 == _G.yiyu_iconhide5 then inst.MiniMapEntity:SetIcon( "yiyu_evergreen.tex" ) end end
		if inst.prefab == "evergreen_sparse" then if TUNING.YIYUICONHIDE6 == _G.yiyu_iconhide6 then inst.MiniMapEntity:SetIcon( "yiyu_evergreen.tex" ) end end
		if inst.prefab == "teatree" then if TUNING.YIYUICONHIDE9 == _G.yiyu_iconhide9 then inst.MiniMapEntity:SetIcon( "yiyu_evergreen.tex" ) end end
		if inst.prefab == "jungletree" then if TUNING.YIYUICONHIDE10 == _G.yiyu_iconhide10 then inst.MiniMapEntity:SetIcon( "yiyu_evergreen.tex" ) end end
		if inst.prefab == "clawpalmtree" then if TUNING.YIYUICONHIDE11 == _G.yiyu_iconhide11 then inst.MiniMapEntity:SetIcon( "yiyu_evergreen.tex" ) end end
		if inst.prefab == "rainforesttree" then if TUNING.YIYUICONHIDE12 == _G.yiyu_iconhide12 then inst.MiniMapEntity:SetIcon( "yiyu_evergreen.tex" ) end end
	elseif inst:HasTag("burnt") then
		inst.MiniMapEntity:SetIcon("yiyu_burnt.tex")
	else
		if inst.prefab == "evergreen" then if TUNING.YIYUICONHIDE5 == _G.yiyu_iconhide5 then inst.MiniMapEntity:SetIcon( "evergreen.png" ) end end
		if inst.prefab == "evergreen_sparse" then if TUNING.YIYUICONHIDE6 == _G.yiyu_iconhide6 then inst.MiniMapEntity:SetIcon( "evergreen_lumpy.png" ) end end
		if inst.prefab == "deciduoustree" then if TUNING.YIYUICONHIDE7 == _G.yiyu_iconhide7 then inst.MiniMapEntity:SetIcon( "tree_leaf.png" ) end end
		if inst.prefab == "palmtree" then if TUNING.YIYUICONHIDE8 == _G.yiyu_iconhide8 then inst.MiniMapEntity:SetIcon( "palmTree.png" ) end end
		if inst.prefab == "teatree" then if TUNING.YIYUICONHIDE9 == _G.yiyu_iconhide9 then inst.MiniMapEntity:SetIcon( "teatree.png" ) end end
		if inst.prefab == "jungletree" then if TUNING.YIYUICONHIDE10 == _G.yiyu_iconhide10 then inst.MiniMapEntity:SetIcon( "jungleTree.png" ) end end
		if inst.prefab == "clawpalmtree" then if TUNING.YIYUICONHIDE11 == _G.yiyu_iconhide11 then inst.MiniMapEntity:SetIcon( "claw_tree.png" ) end end
		if inst.prefab == "rainforesttree" then if TUNING.YIYUICONHIDE12 == _G.yiyu_iconhide12 then inst.MiniMapEntity:SetIcon( "tree_rainforest.png" ) end end
		if inst.prefab == "spider_monkey_tree" then inst.MiniMapEntity:SetIcon( "spiderTree.png" ) end
	end
end
end

for k,v in pairs(tree_icons) do
	AddPrefabPostInit(v,function(inst)
		inst.MiniMapEntity:SetPriority(-1)
		inst:DoTaskInTime(1, function() check_stump(inst) end)
		inst:ListenForEvent("workfinished",function(inst,data) check_stump(inst) end)
		inst:ListenForEvent("onextinguish",function(inst,data) check_stump(inst) end)
--		inst:ListenForEvent("onignite",function(inst,data) check_stump(inst) end)
	end)
end
]]
-------------------------------------------------------

local grass_icons = 
{
	"flower",
	"grass",
	"sapling",
	"reeds",
	"seaweed_planted",
	"red_mushroom",
	"green_mushroom",
	"blue_mushroom",
	"berrybush",--浆果
	"berrybush2",--浆果2
	"flower_cave",
	"flower_cave_double",
	"flower_cave_triple",
	"reeds_water",
	"bambootree",--竹子
	"grass_tall",--高草丛
	"lotus",
}


local function check_pick(inst,root)
	if root == nil and inst then
	local c = inst.components
		if c.pickable and c.pickable.canbepicked then
			root=0
		elseif c.hackable and c.hackable.canbehacked then
			root=0
		elseif c.shearable and c.shearable.canshear then
			root=0
		else
			root=1
		end
	end
	if root==0 then
		if inst and inst.prefab == "flower" then if TUNING.YIYUICONHIDE1 == _G.yiyu_iconhide1 then inst.MiniMapEntity:SetIcon("flowericon.tex") end end
		if inst and inst.prefab == "grass" then if TUNING.YIYUICONHIDE2 == _G.yiyu_iconhide2 then inst.MiniMapEntity:SetIcon("grass.png") end end
		if inst and inst.prefab == "grass_tall" then if TUNING.YIYUICONHIDE3 == _G.yiyu_iconhide3 then inst.MiniMapEntity:SetIcon("grass.png") end end
		if inst and inst.prefab == "sapling" then if TUNING.YIYUICONHIDE4 == _G.yiyu_iconhide4 then inst.MiniMapEntity:SetIcon("sapling.png") end end
		if inst and inst.prefab == "reeds" then inst.MiniMapEntity:SetIcon( "reeds.png" ) end
		if inst and inst.prefab == "lotus" then inst.MiniMapEntity:SetIcon( "lotus.png" ) end
		if inst and inst.prefab == "reeds_water" then inst.MiniMapEntity:SetIcon( "reeds.png" ) end
		if inst and inst.prefab == "seaweed_planted" then inst.MiniMapEntity:SetIcon( "seaweed.png" ) end
		if inst and inst.prefab == "bambootree" then inst.MiniMapEntity:SetIcon( "bambootree.png" ) end
		if inst and inst.prefab == "red_mushroom" then inst.MiniMapEntity:SetIcon( "red_mushroom.tex" ) end
		if inst and inst.prefab == "green_mushroom" then inst.MiniMapEntity:SetIcon( "green_mushroom.tex" ) end
		if inst and inst.prefab == "blue_mushroom" then inst.MiniMapEntity:SetIcon( "blue_mushroom.tex" ) end
		if inst and inst.prefab == "berrybush" then inst.MiniMapEntity:SetIcon( "berrybush.png" ) end
		if inst and inst.prefab == "berrybush2" then inst.MiniMapEntity:SetIcon( "berrybush2.png" ) end
		if inst and inst.prefab == "flower_cave" then inst.MiniMapEntity:SetIcon( "bulb_plant.png" ) end
		if inst and inst.prefab == "flower_cave_double" then inst.MiniMapEntity:SetIcon( "flower_cave_double.tex" ) end
		if inst and inst.prefab == "flower_cave_triple" then inst.MiniMapEntity:SetIcon( "flower_cave_triple.tex" ) end
	elseif root==1 then
		if inst and inst.prefab == "flower" then if TUNING.YIYUICONHIDE1 == _G.yiyu_iconhide1 then inst.MiniMapEntity:SetIcon("flowericon.tex") end end
		if inst and inst.prefab == "grass" then if TUNING.YIYUICONHIDE2 == _G.yiyu_iconhide2 then inst.MiniMapEntity:SetIcon("yiyu_grass.tex") end end
		if inst and inst.prefab == "grass_tall" then if TUNING.YIYUICONHIDE3 == _G.yiyu_iconhide3 then inst.MiniMapEntity:SetIcon("yiyu_grass.tex") end end
		if inst and inst.prefab == "sapling" then if TUNING.YIYUICONHIDE4 == _G.yiyu_iconhide4 then inst.MiniMapEntity:SetIcon("yiyu_sapling.tex") end end
		if inst and inst.prefab == "lotus" then inst.MiniMapEntity:SetIcon( "yiyu_lotus.tex" ) end
		if inst and inst.prefab == "reeds" then inst.MiniMapEntity:SetIcon( "yiyu_reeds.tex" ) end
		if inst and inst.prefab == "reeds_water" then inst.MiniMapEntity:SetIcon( "yiyu_reeds.tex" ) end
		if inst and inst.prefab == "seaweed_planted" then inst.MiniMapEntity:SetIcon( "yiyu_seaweed_planted.tex" ) end
		if inst and inst.prefab == "bambootree" then inst.MiniMapEntity:SetIcon( "yiyu_bambootree.tex" ) end
		if inst and inst.prefab == "berrybush" then inst.MiniMapEntity:SetIcon( "yiyu_berrybush.tex" ) end
		if inst and inst.prefab == "berrybush2" then inst.MiniMapEntity:SetIcon( "yiyu_berrybush2.tex" ) end
		if inst and inst.prefab == "red_mushroom" then inst.MiniMapEntity:SetIcon( "yiyu_red_mushroom.tex" ) end
		if inst and inst.prefab == "blue_mushroom" then inst.MiniMapEntity:SetIcon( "yiyu_blue_mushroom.tex" ) end
		if inst and inst.prefab == "green_mushroom" then inst.MiniMapEntity:SetIcon( "yiyu_green_mushroom.tex" ) end
		if inst and inst.prefab == "flower_cave" then inst.MiniMapEntity:SetIcon( "yiyu_flower_cave.tex" ) end
		if inst and inst.prefab == "flower_cave_double" then inst.MiniMapEntity:SetIcon( "yiyu_flower_cave.tex" ) end
		if inst and inst.prefab == "flower_cave_triple" then inst.MiniMapEntity:SetIcon( "yiyu_flower_cave.tex" ) end
	end
end

for k,v in pairs(grass_icons) do
	AddPrefabPostInit(v,function(inst)
		inst.entity:AddMiniMapEntity()
		inst:DoTaskInTime(1, function() check_pick(inst) end)
	end)
end

Inject("pickable","Regen",function(inst) check_pick(inst) end)
Inject("pickable","MakeBarren",function(inst) check_pick(inst) end)
Inject("pickable","OnTransplant",function(inst) check_pick(inst) end)
Inject("pickable","MakeEmpty",function(inst) check_pick(inst) end)
Inject("pickable","Pick",function(inst) check_pick(inst) end)
Inject("hackable","Rejuvenate",function(inst) check_pick(inst) end)
Inject("hackable","Regen",function(inst) check_pick(inst) end)
Inject("hackable","MakeBarren",function(inst) check_pick(inst) end)
Inject("hackable","MakeEmpty",function(inst) check_pick(inst) end)
Inject("hackable","OnTransplant",function(inst) check_pick(inst) end)
Inject("hackable","Hack",function(inst) check_pick(inst) end)--hacked
Inject("shearable","Shear",function(inst) check_pick(inst) end)

-------------------------------------已有图标显示
yiyuicons=
{
	"flowericon",--花
	"yiyu_grass",
	"yiyu_sapling",
	"yiyu_reeds",
	"yiyu_lotus",
	"yiyu_seaweed_planted",
	"yiyu_bambootree",
	"yiyu_red_mushroom",
	"yiyu_green_mushroom",
	"yiyu_blue_mushroom",
	"yiyu_flower_cave",
	"yiyu_berrybush",--浆果
	"yiyu_berrybush2",--浆果
	"yiyu_empty",--

	"green_mushroom",	--绿蘑菇
	"blue_mushroom",--蓝蘑菇
	"red_mushroom",--红蘑菇
	"flower_cave_double",--洞穴花2
	"flower_cave_triple",--洞穴花3

	"radish_planted",--水萝卜
	"aloe_planted",--芦荟
	"asparagus_planted",--芦笋

	"jellyfish_planted",--水母
	"solofish",--狗鱼
	"flup",--沼跃鱼
	"sandhill",--沙丘
	"seashell_beached",--贝壳
	"frog",--青蛙
	"crabhole",--螃蟹洞
	"bat",--蝙蝠
	"rocky",--石虾
	"snurtle",--黏糊虫
	"worm",--蠕虫
	"slurper",--啜食者

	"roc_head",--roc
	"pugalisk",--pugalisk
	"scorpion",--pugalisk
	"antman",--pugalisk
	"antman_warrior",--pugalisk

	"hedge_block",--草墙
	"hedge_cone",--草墙
	"hedge_layered",--草墙

	"wall_hay",--草墙
	"wall_moonrock",--月亮石墙
	"wall_ruins",--铥墙
	"wall_stone",--石墙
	"wall_wood",--木墙
	"sandbag",--沙袋
	"wall_limestone",--石灰墙
	"waxwelljournal",--麦斯威尔的日志
	"tentacle",--触手	
	"tentacle_pillar",--触手
	"crawlinghorror",--影怪1
	"crawlingnightmare",--影怪2
	"terrorbeak",--尖喙影怪2
	"nightmarebeak",--尖喙影怪
	"mosquito_poison",--蚊子
	"fireflies",--萤火虫
--	"fishinhole",--热带鱼群
	"molehill",--鼹鼠窝
	"rainbowjellyfish_planted",--彩虹水母
	"rainbowjellyfish",

	"flint",--燧石
	"rock2",--金矿
	"carrot_planted",--萝卜
	"rabbithole",--兔子洞
	"whale_blue",--蓝鲸
	"whale_white",--白鲸
	"magmarock_gold",--熔岩金矿
	"volcanostaff",--火山权杖
	"livingjungletree",--活木
	"obsidian",--黑曜石
	"knightboat",--齿轮船
	"bioluminescence",--荧光生物
	"ballphin",--黑海豚
	"swordfish",--剑鱼
	"packim_fishbone",--鱼骨
	"chester_eyebone",--眼骨
	"twister",--风暴BOSS
	"tigershark",--虎鲨BOSS	
	"animal_track",--陷阱
	"dirtpile",--可疑的土堆
	"whale_bubbles",--鲸鱼泡
	"mandrake",--曼德拉草
	"coffeebush",--浆果
	"sharx",--海狗
	"hound",--狗
	"icehound",--冰狗
	"firehound",--火狗
	"houndbone",--狗窝

	"crocodog",--鳄鱼
	"watercrocodog",--鳄鱼2
	"poisoncrocodog",--鳄鱼3

	"snakeden",--蛇藤
	"pighead",--猪头棍
	"scorched_skeleton",--骨架烧焦
	"skeleton",--骨架
	"skeleton_player",--骨架玩家
	"teleportato_box",--零件1
	"teleportato_crank",--零件2
	"teleportato_potato",--零件3
	"teleportato_ring",--零件4
	"teleportato_sw_box",--零件1
	"teleportato_sw_crank",--零件2
	"teleportato_sw_potato",--零件3
	"teleportato_sw_ring",--零件4
	"koalefant_summer",--大象7
	"koalefant_winter",--大象8
	"warg",--座狼
	"krampus",--坎普斯
	"lightninggoat",--山羊
	"ancient_altar",--远古祭坛
	"ancient_altar_broken",--损坏的祭坛
	"minotaur",--远古犀牛
	"mossling",--小鸭子
	"moose",--卤鸭
	"mooseegg",--卤鸭蛋
	"dragonfly",--蜻蜓
	"bearger",--熊
	"deerclops",--巨鹿
	"knight",--发条骑士
	"knight_nightmare",--发条骑士2
	"rook",--战车
	"rook_nightmare",--战车2
	"bishop",--主教
	"bishop_nightmare",--主教2
	"ghost",--幽灵
	"walrus",--海象
	"littlewalrus",--海象
	"pigman",--猪人
	"wildbore",--野猪人
	"bunnyman",--兔人
	"mermhouse_fisher",--鱼人房2
	"doydoy",--渡渡鸟
	"doydoybaby",
	"ox",--水牛
	"beefalo",--牛
	"babybeefalo",--小牛
	"leif",--树精
	"leif_sparse",--稀有树精
	"spiderqueen",--蜘蛛女王
	"merm",--鱼人
	"pigguard",--猪人守卫
	"tallbird",--高鸟
	"monkey",--猴子
	"treeguard",--椰子树精
	"dragoon",--小火龙
	"primeape",--猴子
	"icemerm",--水晶鱼人
	"qiuqiu",--球球

	"rpg_spider",--烈焰狗王
	"rpg_butterfly",--枯萎蜘蛛
	"rpg_hound",--凤仙蝶

--	"pigman_hunter",--浆果猪人
	"pigman_usher",--浆果猪人
	"pigman_storeowner",--换草黄发猪人
	"pigman_mechanic",--草绳猪人
	"hippopotamoose",--鹿角河马
	"frog_poison",--毒青蛙
	"mandrakeman",--曼德拉人
	"mean_flytrap",--食人花小
	"vampirebat",--吸血蝙蝠
	"peagawk",--孔雀
	"spider_monkey",--蜘蛛巨猿
	"pog",--小猫
	"snake_amphibious",--两栖
	"zeb",--海马
	"rabid_beetle",--瓢虫

	"spider_dropper",--瓢虫
	"spider_hider",--瓢虫
	"spider_spitter",--瓢虫

	"relic_1",--古董
	"relic_2",--古董
	"relic_3",--古董

	"rpg_robot1",--古董
	"rpg_robot2",--古董
	"rpg_robot3",--古董
	"rpg_robot4",--古董

	"yiyu_klaus",
	"yiyu_bearger",
	"yiyu_dragonfly",
	"yiyu_boss_stone",
	"lock_skullchest",

	"redgem",
	"bluegem",
	"purplegem",
	"greengem",
	"orangegem",
	"yellowgem",
-------------------------------
--	"yiyu_palmtree",
--	"yiyu_deciduoustree",
--	"yiyu_evergreen",
--	"yiyu_burnt",
--	"mandrakehouse"--蔓草屋
--	"pigbandit",--蒙面猪
--	"pigman_beautician",--蒙面猪
--	"pigman_florist",--蒙面猪
--	"pigman_erudite",--蒙面猪
--	"pigman_hatmaker",--蒙面猪
--	"pigman_banker",--蒙面猪
--	"pigman_collector",--蒙面猪
--	"pigman_mayor",--蒙面猪
--	"pigman_professor",--蒙面猪
--	"pigman_usher",--蒙面猪
--	"pigman_royalguard",--蒙面猪
--	"pigman_royalguard_2",--蒙面猪
--	"pigman_farmer",--蒙面猪
--	"pigman_miner",--蒙面猪
--	"pigman_queen",--蒙面猪
--	"pigman_beautician_shopkeep",--蒙面猪
--	"pigman_florist_shopkeep",--蒙面猪
--	"pigman_erudite_shopkeep",--蒙面猪
--	"pigman_hatmaker_shopkeep",--蒙面猪
--	"pigman_storeowner_shopkeep",--蒙面猪
--	"pigman_banker_shopkeep",--蒙面猪
--	"pigman_shopkeep",--蒙面猪
--	"pigman_hunter_shopkeep",--蒙面猪
--	"pigman_mayor_shopkeep",--蒙面猪
--	"pigman_farmer_shopkeep",--蒙面猪
--	"pigman_miner_shopkeep",--蒙面猪
--	"pigman_collector_shopkeep",--蒙面猪
--	"pigman_professor_shopkeep",--蒙面猪
--	"chicken",--小鸡
--	"bill",--刺猬
--	"piko",--松鼠
--	"glowfly",--发光虫
--	"grabbing_vine",--树藤
--	"scorpion",--蝎子
--	"antman",--蚂蚁人
--	"antman_warrior",--蚂蚁战士
--	"giantgrub",--巨型鼠妇
--	"pangolden",--食蚁兽
--	雷鸟
--	"snake_fire",--火蛇
--	"pugalisk",--岩蛇
--	老鱼人
--	"adult_flytrap",--食人花大
--	"rabbithole",--兔房
--	"mermhouse",--鱼人房
--	"mermfisher",--老鱼人
--	"marsh_bush",--沼泽灌木
}

function AddMap(name)
	table.insert(Assets, Asset("IMAGE", "images/" .. name .. ".tex"))
	table.insert(Assets, Asset("ATLAS", "images/" .. name .. ".xml"))
	AddMinimapAtlas("images/" .. name .. ".xml")
	if name and name == "flowericon" then
		name = "flower"
	end
	AddPrefabPostInit(name, function(inst)
		inst.entity:AddMiniMapEntity()
		if name and name == "flower" then
			name = "flowericon"
		end
		inst.MiniMapEntity:SetIcon(name .. ".tex")
		local empty = "yiyu_empty.tex"
		if TUNING.YIYUICONHIDE1 == _G.yiyu_iconshow1 and inst.prefab == "flower" then inst.MiniMapEntity:SetIcon(empty) end
		if TUNING.YIYUICONHIDE2 == _G.yiyu_iconshow2 and inst.prefab == "grass" then inst.MiniMapEntity:SetIcon(empty) end
		if TUNING.YIYUICONHIDE3 == _G.yiyu_iconshow3 and inst.prefab == "grass_tall" then inst.MiniMapEntity:SetIcon(empty) end
		if TUNING.YIYUICONHIDE4 == _G.yiyu_iconshow4 and inst.prefab == "sapling" then inst.MiniMapEntity:SetIcon(empty) end
		if TUNING.YIYUICONHIDE5 == _G.yiyu_iconshow5 and inst.prefab == "evergreen" then inst.MiniMapEntity:SetIcon(empty) end
		if TUNING.YIYUICONHIDE6 == _G.yiyu_iconshow6 and inst.prefab == "evergreen_sparse" then inst.MiniMapEntity:SetIcon(empty) end
		if TUNING.YIYUICONHIDE7 == _G.yiyu_iconshow7 and inst.prefab == "deciduoustree" then inst.MiniMapEntity:SetIcon(empty) end
		if TUNING.YIYUICONHIDE8 == _G.yiyu_iconshow8 and inst.prefab == "palmtree" then inst.MiniMapEntity:SetIcon(empty) end
		if TUNING.YIYUICONHIDE9 == _G.yiyu_iconshow9 and inst.prefab == "jungletree" then inst.MiniMapEntity:SetIcon(empty) end
		if TUNING.YIYUICONHIDE10 == _G.yiyu_iconshow10 and inst.prefab == "teatree" then inst.MiniMapEntity:SetIcon(empty) end
		if TUNING.YIYUICONHIDE11 == _G.yiyu_iconshow11 and inst.prefab == "clawpalmtree" then inst.MiniMapEntity:SetIcon(empty) end
		if TUNING.YIYUICONHIDE12 == _G.yiyu_iconshow12 and inst.prefab == "rainforesttree" then inst.MiniMapEntity:SetIcon(empty) end
		if TUNING.YIYUICONHIDE13 == _G.yiyu_iconshow13 and inst.prefab == "flint" then inst.MiniMapEntity:SetIcon(empty) end
		if TUNING.YIYUICONHIDE14 == _G.yiyu_iconshow14 and inst.prefab == "rabbithole" then inst.MiniMapEntity:SetIcon(empty) end
		if TUNING.YIYUICONHIDE15 == _G.yiyu_iconshow15 and inst.prefab == "pigman" then inst.MiniMapEntity:SetIcon(empty) end
		if TUNING.YIYUICONHIDE16 == _G.yiyu_iconshow16 and inst.prefab == "bunnyman" then inst.MiniMapEntity:SetIcon(empty) end
		if TUNING.YIYUICONHIDE17 == _G.yiyu_iconshow17 and inst.prefab == "merm" then inst.MiniMapEntity:SetIcon(empty) end
		if TUNING.YIYUICONHIDE18 == _G.yiyu_iconshow18 and inst.prefab == "frog" then inst.MiniMapEntity:SetIcon(empty) end
		if TUNING.YIYUICONHIDE19 == _G.yiyu_iconshow19 and inst.prefab == "bat" then inst.MiniMapEntity:SetIcon(empty) end
		if TUNING.YIYUICONHIDE20 == _G.yiyu_iconshow20 and inst.prefab == "jellyfish_planted" then inst.MiniMapEntity:SetIcon(empty)end
		if TUNING.YIYUICONHIDE21 == _G.yiyu_iconshow21 and inst.prefab == "rainbowjellyfish_planted" then inst.MiniMapEntity:SetIcon(empty) end
		if TUNING.YIYUICONHIDE22 == _G.yiyu_iconshow22 and inst.prefab == "solofish" then inst.MiniMapEntity:SetIcon(empty) end
		if TUNING.YIYUICONHIDE23 == _G.yiyu_iconshow23 and inst.prefab == "ballphin" then inst.MiniMapEntity:SetIcon(empty) end
		if TUNING.YIYUICONHIDE24 == _G.yiyu_iconshow24 and inst.prefab == "seaweed_planted" then inst.MiniMapEntity:SetIcon(empty) end
--		if TUNING.YIYUICONHIDE25 == _G.yiyu_iconshow25 and inst.prefab == "seashell_beached" then inst.MiniMapEntity:SetIcon(empty) end
--		if TUNING.YIYUICONHIDE26 == _G.yiyu_iconshow26 and inst.prefab == "sandhill" then inst.MiniMapEntity:SetIcon(empty) end
--		if TUNING.YIYUICONHIDE27 == _G.yiyu_iconshow27 and inst.prefab == "crabhole" then inst.MiniMapEntity:SetIcon(empty) end
--		if TUNING.YIYUICONHIDE28 == _G.yiyu_iconshow28 and inst.prefab == "rabid_beetle" then inst.MiniMapEntity:SetIcon(empty) end
--		if TUNING.YIYUICONHIDE29 == _G.yiyu_iconshow29 and inst.prefab == "mean_flytrap" then inst.MiniMapEntity:SetIcon(empty) end
--		if TUNING.YIYUICONHIDE30 == _G.yiyu_iconshow30 and inst.prefab == "null" then inst.MiniMapEntity:SetIcon(empty) end
	end)
end
for k,v in pairs(yiyuicons) do AddMap(v) end

---------------------------------------------------------------

local function rainbowjellyfish(inst)
local function OnEntitySleep(inst, data)
	if inst.hidden then
		inst.MiniMapEntity:SetIcon( "rainbowjellyfish.tex" )
	else
		inst.MiniMapEntity:SetIcon( "rainbowjellyfish_planted.tex" )
	end
end

local function OnEntityWake(inst, data)
	if inst.hidden then
		inst.MiniMapEntity:SetIcon( "rainbowjellyfish.tex" )
	else
		inst.MiniMapEntity:SetIcon( "rainbowjellyfish_planted.tex" )
	end
end
	if TUNING.YIYUICONHIDE21 == _G.yiyu_iconshow21 then
		inst.MiniMapEntity:SetIcon("yiyu_empty.tex")
	elseif TUNING.YIYUICONHIDE21 == _G.yiyu_iconhide21 then
		inst.entity:AddMiniMapEntity()
		inst:ListenForEvent("entitysleep", OnEntitySleep)
		inst:ListenForEvent("entitywake", OnEntityWake)
	end
end
AddPrefabPostInit( "rainbowjellyfish_planted", rainbowjellyfish )
AddPrefabPostInit( "walrus_camp", function(inst) inst:AddTag("walrus_camp") end)
AddPrefabPostInit( "cave_entrance", function(inst) inst:AddTag("cave_entrance") end)
AddPrefabPostInit( "slotmachine", function(inst) inst:AddTag("slotmachine") end)
AddPrefabPostInit( "livingtree", function(inst) inst:AddTag("yiyu_liveingtree") end)
AddPrefabPostInit( "livingjungletree", function(inst) inst:AddTag("yiyu_liveingtree") end)
AddPrefabPostInit( "statueglommer", function(inst) inst:AddTag("statueglommer") end)

_G.MapReload_yiyu = function()
	local player = GLOBAL.GetPlayer()
		local pos = GLOBAL.Vector3(player.Transform:GetWorldPosition())
		local ents = GLOBAL.TheSim:FindEntities(pos.x,pos.y,pos.z, 3000)
		local empimg = "yiyu_empty.tex"
		local YIYU_MOD_MAPCHEAK = 
		{
			"flower","grass","grass_tall","sapling","spider_monkey_tree","evergreen","evergreen_sparse","deciduoustree","palmtree","teatree","jungletree","clawpalmtree",
			"flint","rabbithole","pigman","bunnyman","merm","frog","bat","jellyfish_planted","rainbowjellyfish_planted","solofish","ballphin","seaweed_planted","rainforesttree",
		}
--------------------------开始判断该世界的恶劣环境
		for k,v in pairs(ents) do
				local root = 0
				local c = v and v.components
				if c.pickable and c.pickable.canbepicked then
					root = 0
				elseif c.hackable and c.hackable.canbehacked then
					root = 0
				elseif c.shearable and c.shearable.canshear then
					root = 0
				else
					root = 1
				end
			if table.contains(YIYU_MOD_MAPCHEAK, v.prefab) then
			if root==0 then
				if v and v.prefab == "flower" then if TUNING.YIYUICONHIDE1 == _G.yiyu_iconhide1 then v.MiniMapEntity:SetIcon("flowericon.tex") end end
				if v and v.prefab == "grass" then if TUNING.YIYUICONHIDE2 == _G.yiyu_iconhide2 then v.MiniMapEntity:SetIcon("grass.png") end end
				if v and v.prefab == "grass_tall" then if TUNING.YIYUICONHIDE3 == _G.yiyu_iconhide3 then v.MiniMapEntity:SetIcon("grass.png") end end
				if v and v.prefab == "sapling" then if TUNING.YIYUICONHIDE4 == _G.yiyu_iconhide4 then v.MiniMapEntity:SetIcon("sapling.png") end end
			end
			if root==1 then
				if v and v.prefab == "flower" then if TUNING.YIYUICONHIDE1 == _G.yiyu_iconhide1 then v.MiniMapEntity:SetIcon("flowericon.tex") end end
				if v and v.prefab == "grass" then if TUNING.YIYUICONHIDE2 == _G.yiyu_iconhide2 then v.MiniMapEntity:SetIcon("yiyu_grass.tex") end end
				if v and v.prefab == "grass_tall" then if TUNING.YIYUICONHIDE3 == _G.yiyu_iconhide3 then v.MiniMapEntity:SetIcon("yiyu_grass.tex") end end
				if v and v.prefab == "sapling" then if TUNING.YIYUICONHIDE4 == _G.yiyu_iconhide4 then v.MiniMapEntity:SetIcon("yiyu_sapling.tex") end end
			end
--[[
			if v and v:HasTag("stump") then
				if v and v.prefab == "spider_monkey_tree" then v.MiniMapEntity:SetIcon( "yiyu_deciduoustree.tex" ) end
				if v and v.prefab == "evergreen" then if TUNING.YIYUICONHIDE5 == _G.yiyu_iconhide5 then v.MiniMapEntity:SetIcon( "yiyu_evergreen.tex" ) end end
				if v and v.prefab == "evergreen_sparse" then if TUNING.YIYUICONHIDE6 == _G.yiyu_iconhide6 then v.MiniMapEntity:SetIcon( "yiyu_evergreen.tex" ) end end
				if v and v.prefab == "deciduoustree" then if TUNING.YIYUICONHIDE7 == _G.yiyu_iconhide7 then v.MiniMapEntity:SetIcon( "yiyu_deciduoustree.tex" ) end end
				if v and v.prefab == "palmtree" then if TUNING.YIYUICONHIDE8 == _G.yiyu_iconhide8 then v.MiniMapEntity:SetIcon( "yiyu_palmtree.tex" ) end end
				if v and v.prefab == "teatree" then if TUNING.YIYUICONHIDE9 == _G.yiyu_iconhide9 then v.MiniMapEntity:SetIcon( "yiyu_evergreen.tex" ) end end
				if v and v.prefab == "jungletree" then if TUNING.YIYUICONHIDE10 == _G.yiyu_iconhide10 then v.MiniMapEntity:SetIcon( "yiyu_evergreen.tex" ) end end
				if v and v.prefab == "clawpalmtree" then if TUNING.YIYUICONHIDE11 == _G.yiyu_iconhide11 then v.MiniMapEntity:SetIcon( "yiyu_evergreen.tex" ) end end
				if v and v.prefab == "rainforesttree" then if TUNING.YIYUICONHIDE12 == _G.yiyu_iconhide12 then v.MiniMapEntity:SetIcon( "yiyu_evergreen.tex" ) end end
			end
			if v and v:HasTag("burnt") then v.MiniMapEntity:SetIcon("yiyu_burnt.tex") end
]]
			if v and not v:HasTag("stump") and not v:HasTag("burnt") then
				if v and v.prefab == "evergreen" then if TUNING.YIYUICONHIDE5 == _G.yiyu_iconhide5 then v.MiniMapEntity:SetIcon( "evergreen.png" ) end end
				if v and v.prefab == "evergreen_sparse" then if TUNING.YIYUICONHIDE6 == _G.yiyu_iconhide6 then v.MiniMapEntity:SetIcon( "evergreen_lumpy.png" ) end end
				if v and v.prefab == "deciduoustree" then if TUNING.YIYUICONHIDE7 == _G.yiyu_iconhide7 then v.MiniMapEntity:SetIcon( "tree_leaf.png" ) end end
				if v and v.prefab == "palmtree" then if TUNING.YIYUICONHIDE8 == _G.yiyu_iconhide8 then v.MiniMapEntity:SetIcon( "palmTree.png" ) end end
				if v and v.prefab == "teatree" then if TUNING.YIYUICONHIDE9 == _G.yiyu_iconhide9 then v.MiniMapEntity:SetIcon( "teatree.png" ) end end
				if v and v.prefab == "jungletree" then if TUNING.YIYUICONHIDE10 == _G.yiyu_iconhide10 then v.MiniMapEntity:SetIcon( "jungleTree.png" ) end end
				if v and v.prefab == "clawpalmtree" then if TUNING.YIYUICONHIDE11 == _G.yiyu_iconhide11 then v.MiniMapEntity:SetIcon( "claw_tree.png" ) end end
				if v and v.prefab == "rainforesttree" then if TUNING.YIYUICONHIDE12 == _G.yiyu_iconhide12 then v.MiniMapEntity:SetIcon( "tree_rainforest.png" ) end
				if v and v.prefab == "spider_monkey_tree" then v.MiniMapEntity:SetIcon( "spiderTree.png" ) end end
			end

			if TUNING.YIYUICONHIDE13 == _G.yiyu_iconhide13 and v and v.prefab == "flint" then v.MiniMapEntity:SetIcon("flint.tex") end
			if TUNING.YIYUICONHIDE14 == _G.yiyu_iconhide14 and v and v.prefab == "rabbithole" then v.MiniMapEntity:SetIcon("rabbithole.tex") end
			if TUNING.YIYUICONHIDE15 == _G.yiyu_iconhide15 and v and v.prefab == "pigman" then v.MiniMapEntity:SetIcon("pigman.tex") end
			if TUNING.YIYUICONHIDE16 == _G.yiyu_iconhide16 and v and v.prefab == "bunnyman" then v.MiniMapEntity:SetIcon("bunnyman.tex") end
			if TUNING.YIYUICONHIDE17 == _G.yiyu_iconhide17 and v and v.prefab == "merm" then v.MiniMapEntity:SetIcon("merm.tex") end
			if TUNING.YIYUICONHIDE18 == _G.yiyu_iconhide18 and v and v.prefab == "frog" then v.MiniMapEntity:SetIcon("frog.tex") end
			if TUNING.YIYUICONHIDE19 == _G.yiyu_iconhide19 and v and v.prefab == "bat" then v.MiniMapEntity:SetIcon("bat.tex") end
			if TUNING.YIYUICONHIDE20 == _G.yiyu_iconhide20 and v and v.prefab == "jellyfish_planted" then v.MiniMapEntity:SetIcon("jellyfish_planted.tex") end
			if TUNING.YIYUICONHIDE21 == _G.yiyu_iconhide21 and v and v.prefab == "rainbowjellyfish_planted" then v.MiniMapEntity:SetIcon("rainbowjellyfish_planted.tex") end
			if TUNING.YIYUICONHIDE22 == _G.yiyu_iconhide22 and v and v.prefab == "solofish" then v.MiniMapEntity:SetIcon("solofish.tex") end
			if TUNING.YIYUICONHIDE23 == _G.yiyu_iconhide23 and v and v.prefab == "ballphin" then v.MiniMapEntity:SetIcon("ballphin.tex") end
			if TUNING.YIYUICONHIDE24 == _G.yiyu_iconhide24 and v and v.prefab == "seaweed_planted" then v.MiniMapEntity:SetIcon("seaweed.png") end
--			if TUNING.YIYUICONHIDE25 == _G.yiyu_iconhide25 and v and v.prefab == "seashell_beached" then v.MiniMapEntity:SetIcon("seashell_beached.tex") end
--			if TUNING.YIYUICONHIDE26 == _G.yiyu_iconhide26 and v and v.prefab == "sandhill" then v.MiniMapEntity:SetIcon("sandhill.tex") end

			if TUNING.YIYUICONHIDE1 == _G.yiyu_iconshow1 then if v and v.prefab == "flower" then v.MiniMapEntity:SetIcon(empimg) end end
			if TUNING.YIYUICONHIDE2 == _G.yiyu_iconshow2 then if v and v.prefab == "grass" then v.MiniMapEntity:SetIcon(empimg) end end
			if TUNING.YIYUICONHIDE3 == _G.yiyu_iconshow3 then if v and v.prefab == "grass_tall" then v.MiniMapEntity:SetIcon(empimg) end end
			if TUNING.YIYUICONHIDE4 == _G.yiyu_iconshow4 then if v and v.prefab == "sapling" then v.MiniMapEntity:SetIcon(empimg) end end
			if TUNING.YIYUICONHIDE5 == _G.yiyu_iconshow5 then if v and v.prefab == "evergreen" then v.MiniMapEntity:SetIcon(empimg) end end
			if TUNING.YIYUICONHIDE6 == _G.yiyu_iconshow6 then if v and v.prefab == "evergreen_sparse" then v.MiniMapEntity:SetIcon(empimg) end end
			if TUNING.YIYUICONHIDE7 == _G.yiyu_iconshow7 then if v and v.prefab == "deciduoustree" then v.MiniMapEntity:SetIcon(empimg) end end
			if TUNING.YIYUICONHIDE8 == _G.yiyu_iconshow8 then if v and v.prefab == "palmtree" then v.MiniMapEntity:SetIcon(empimg) end end
			if TUNING.YIYUICONHIDE9 == _G.yiyu_iconshow9 then if v and v.prefab == "teatree" then v.MiniMapEntity:SetIcon(empimg) end end
			if TUNING.YIYUICONHIDE10 == _G.yiyu_iconshow10 then if v and v.prefab == "jungletree" then v.MiniMapEntity:SetIcon(empimg) end end
			if TUNING.YIYUICONHIDE11 == _G.yiyu_iconshow11 then if v and v.prefab == "clawpalmtree" then v.MiniMapEntity:SetIcon(empimg) end end
			if TUNING.YIYUICONHIDE12 == _G.yiyu_iconshow12 then if v and v.prefab == "rainforesttree" then v.MiniMapEntity:SetIcon(empimg) end end

			if TUNING.YIYUICONHIDE13 == _G.yiyu_iconshow13 and v and v.prefab == "flint" then v.MiniMapEntity:SetIcon(empimg) end
			if TUNING.YIYUICONHIDE14 == _G.yiyu_iconshow14 and v and v.prefab == "rabbithole" then v.MiniMapEntity:SetIcon(empimg) end
			if TUNING.YIYUICONHIDE15 == _G.yiyu_iconshow15 and v and v.prefab == "pigman" then v.MiniMapEntity:SetIcon(empimg) end
			if TUNING.YIYUICONHIDE16 == _G.yiyu_iconshow16 and v and v.prefab == "bunnyman" then v.MiniMapEntity:SetIcon(empimg) end
			if TUNING.YIYUICONHIDE17 == _G.yiyu_iconshow17 and v and v.prefab == "merm" then v.MiniMapEntity:SetIcon(empimg) end
			if TUNING.YIYUICONHIDE18 == _G.yiyu_iconshow18 and v and v.prefab == "frog" then v.MiniMapEntity:SetIcon(empimg) end
			if TUNING.YIYUICONHIDE19 == _G.yiyu_iconshow19 and v and v.prefab == "bat" then v.MiniMapEntity:SetIcon(empimg) end
			if TUNING.YIYUICONHIDE20 == _G.yiyu_iconshow20 and v and v.prefab == "jellyfish_planted" then v.MiniMapEntity:SetIcon(empimg) end
			if TUNING.YIYUICONHIDE21 == _G.yiyu_iconshow21 and v and v.prefab == "rainbowjellyfish_planted" then v.MiniMapEntity:SetIcon(empimg) end
			if TUNING.YIYUICONHIDE22 == _G.yiyu_iconshow22 and v and v.prefab == "solofish" then v.MiniMapEntity:SetIcon(empimg) end
			if TUNING.YIYUICONHIDE23 == _G.yiyu_iconshow23 and v and v.prefab == "ballphin" then v.MiniMapEntity:SetIcon(empimg) end
			if TUNING.YIYUICONHIDE24 == _G.yiyu_iconshow24 and v and v.prefab == "seaweed_planted" then v.MiniMapEntity:SetIcon(empimg) end
--			if TUNING.YIYUICONHIDE25 == _G.yiyu_iconshow25 and v and v.prefab == "seashell_beached" then v.MiniMapEntity:SetIcon(empimg) end
--			if TUNING.YIYUICONHIDE26 == _G.yiyu_iconshow26 and v and v.prefab == "sandhill" then v.MiniMapEntity:SetIcon(empimg) end
			end
		end
end

